/* -*- Mode: C++; indent-tabs-mode: nil; tab-width: 4 -*-
 * -*- coding: utf-8 -*-
 *
 * Copyright (C) 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "touchpad.h"

TouchpadManager::TouchpadManager(QObject *parent):
    QObject(parent)
{
    QDBusConnection::sessionBus().connect("org.ukui.SettingsDaemon",
                                          "/org/ukui/SettingsDaemon/InputManager",
                                          "org.ukui.SettingsDaemon.InputManager",
                                          "touchpadStateChanged",
                                         this, SLOT(onTouchpadStateChanged(bool)));

    initSignals();
}

TouchpadManager::~TouchpadManager()
{

}

bool TouchpadManager::IsEnable()
{
   QDBusReply<bool> reply = callInputDbus("getTouchpadState");
   if (reply.isValid()) {
        return reply.value();
   }

   return false;
}

void TouchpadManager::Enable(bool state)
{
    callInputDbus("setTouchpadState", state);
}

int TouchpadManager::GetTouchpadCount()
{
    QDBusInterface deviceManagerInterface(USD_SESSION_SERVER,
                                USD_SESSION_PATH,
                                USD_SESSION_INTERFACE,
                                QDBusConnection::sessionBus());
    QDBusReply<int> reply = deviceManagerInterface.call(USD_METHOD_GETDEVCOUNTBYTYPE, "touchpad");
    return reply.isValid() ? reply.value() : -1;
}

void TouchpadManager::onTouchpadStateChanged(bool state)
{
    Q_EMIT EnableChanged(state);
}

template <typename...Args>
QDBusMessage TouchpadManager::callInputDbus(const QString &method, Args &&...args)
{
    QDBusInterface inputManagerInterface(USD_SESSION_SERVER,
                                         USD_SESSION_PATH,
                                         USD_SESSION_INTERFACE);
    return inputManagerInterface.call(method, std::forward<Args>(args)...);
}

void TouchpadManager::initSignals()
{
    QDBusConnection::sessionBus().connect(USD_SESSION_SERVER,
                                         USD_SESSION_PATH,
                                         USD_SESSION_INTERFACE,
                                         USD_SIGNAL_TOUCHPADCOUNTCHANGED,
                                         this,
                                         SIGNAL(TouchpadCountChanged(int)));


}
